--Best = 201

local M = {}

local helper = require('scenario/scenariohelper')
local scenarioTimeOut = 0
local startTimer = false
local start = false
local reset = true
local file = require('scenario/fileHandler')

local function onRaceStart()
	if not start then start = true end
end

local function success(score, team, opponent)
	local medal, nextMedal
	if score < 145 then 
		medal = 'None'
		nextMedal = 'Bronze(145)'
	elseif score >= 145 and score < 155 then 
		medal = 'Bronze'
		nextMedal = 'Silver(155)'
	elseif score >= 155 and score < 165 then 
		medal = 'Silver'
		nextMedal = 'Gold(165)'
	elseif score >= 165 and score < 175 then 
		medal = 'Gold'
		nextMedal = 'Platinum(175)'
	elseif score >= 175 and score < 180 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(180)'
	elseif score >= 180 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 2, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: ('..team..'- '..opponent..') ='..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' then
		helper.queueLuaCommandByName('player', 'bullettime.set(4)')
		startTimer = true
	end
end

local function finish()
	local playerObject = scenetree.findObject('player')
    local car1Object = scenetree.findObject('player1')
    local car2Object = scenetree.findObject('player2')	
	local carOpponentObject = scenetree.findObject('opponent')	
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
	local distanceCar1 = math.floor(math.sqrt(math.pow(car1Object:getPosition().x+563.3, 2) + math.pow(car1Object:getPosition().y+733.6, 2), math.pow(car1Object:getPosition().z+0.01, 2)))
	local distanceCar2 = math.floor(math.sqrt(math.pow(car2Object:getPosition().x+563.3, 2) + math.pow(car2Object:getPosition().y+733.6, 2), math.pow(car2Object:getPosition().z+0.01, 2)))
	local distanceOpponent = math.floor(math.sqrt(math.pow(carOpponentObject:getPosition().x+563.3, 2) + math.pow(carOpponentObject:getPosition().y+733.6, 2), math.pow(carOpponentObject:getPosition().z+0.01, 2)))

	local scorePlayer = 100-distance
	local scoreCar1 = 100-distanceCar1
	local scoreCar2 = 100-distanceCar2
	local scoreOpponent = 100-distanceOpponent

	local scoreFinal = scoreCar1+scoreCar2+scorePlayer-scoreOpponent
	success(scoreFinal, scorePlayer+scoreCar1+scoreCar2, scoreOpponent)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	if startTimer then
		scenarioTimeOut = scenarioTimeOut+raceTickTime
		playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
	else 
		playerObject:queueLuaCommand('obj:setWind(0, 150, 0)')
	end

	if scenarioTimeOut >= 5 then finish() end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M