--Best = 200

local M = {}

local scoreLand = 0
local scoreFinal = 0
local scoreRest = 0
local scenarioTime = 0
local scenarioTimeOut = 0
local distance = 0
local file = require('scenario/fileHandler')

local function onRaceStart()
	if not start then start = true end
end

local function success(score)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 150 then 
		medal = 'Bronze'
		nextMedal = 'Silver(150)'
	elseif score >= 150 and score < 160 then 
		medal = 'Silver'
		nextMedal = 'Gold(160)'
	elseif score >= 160 and score < 170 then 
		medal = 'Gold'
		nextMedal = 'Platinum(170)'
	elseif score >= 170 and score < 180 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(180)'
	elseif score >= 180 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	local extra = ''
	if score == 200 then 
		extra = 'New Trophy Unlocked!'
		file.updateFile(file.getMedalAsNumber(medal), 1, 1, 6)
	else file.updateFile(file.getMedalAsNumber(medal), 1, nil, nil)
	end
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..' '..extra..''}
	scenario_scenarios.finish(result)
end

local function finish()
	scoreRest = 100-math.abs(distance)
	scoreFinal = scoreLand+scoreRest
	success(scoreFinal)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	scenarioTimeOut = scenarioTimeOut+raceTickTime
	
	if scenarioTimeOut >= 35 then finish() end
	
	if scoreLand == 0 then
		if playerObject:getPosition().z <= 5 then 
			scoreLand = 100-distance 
		end
	else
		local playerData = map.objects[map.objectNames['player']]
		scenarioTime = scenarioTime+raceTickTime
		if scenarioTime >= 8 or playerData.vel:length() <= 0.025 then
			finish()
		else
			distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+683.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
		end
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
return M