--Best = 1000

local M = {}

local helper = require('scenario/scenariohelper')
local scenarioTimeOut = 0
local start = false
local reset = true
local finalScore = 0
local ballsPotted = {}
local file = require('scenario/fileHandler')

local function onRaceStart()
	if not start then 
		start = true 
		TorqueScript.eval([[
			triangle_1.position = "10000 0 0";
			triangle_2.position = "10000 0 0";
			triangle_3.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function success(score)
	local medal, nextMedal

	if score < 400 then 
		medal = 'None'
		nextMedal = 'Bronze(400)'
	elseif score >= 400 and score < 500 then 
		medal = 'Bronze'
		nextMedal = 'Silver(500)'
	elseif score >= 500 and score < 600 then 
		medal = 'Silver'
		nextMedal = 'Gold(600)'
	elseif score >= 600 and score < 700 then 
		medal = 'Gold'
		nextMedal = 'Platinum(700)'
	elseif score >= 700 and score < 800 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(800)'
	elseif score >= 800 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 3, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function fail(reason)
  scenario_scenarios.finish({failed = reason})
end

local function onBeamNGTrigger(data)
	if data.subjectName == 'player' then 
		fail('Foul: You drove into a pocket!')
	elseif (data.triggerName == 'pocket1' or data.triggerName == 'pocket2' or data.triggerName == 'pocket3' or data.triggerName == 'pocket4' or data.triggerName == 'pocket5' or data.triggerName == 'pocket6') and data.subjectName ~= 'player' and data.event == 'enter' then 
		finalScore = finalScore+100 
		table.insert(ballsPotted, data.subjectName)
	elseif data.triggerName == 'outside' then
		local potted = false
		
		for key, value in ipairs(ballsPotted) do
			if value == data.subjectName then potted = true end 
		end
		
		if not potted then fail('Foul: A ball flew off the table!') end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			triangle_1.position = "-563.864563 -1213.0249 29.0229187";
			triangle_2.position = "-555.798157 -1213.27441 29.0229187";
			triangle_3.position = "-559.747009 -1206.63586 29.0327263";
		]])
		be:reloadStaticCollision();
		reset = false
	end
end

local function ballsLeft()
	local balls = 0
	for _ in pairs(ballsPotted) do balls = balls+1 end
	
	return 10-balls
end

local function onRaceTick(raceTickTime)
	if start then scenarioTimeOut = scenarioTimeOut+raceTickTime end

	if scenarioTimeOut >= 90 or score == 1000 then success(finalScore) end
	
	ui_message('Time Left:  '..math.floor(90-scenarioTimeOut)..'s', 1, 'A')
	ui_message('Balls Left: '..ballsLeft(), 1, 'B')
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M