--Best = 343

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local file = require('scenario/fileHandler')
local helper = require('scenario/scenariohelper')
--local musicTime = 0
local targetTime = 0
local targetScore = -1

local function onRaceStart()
	if not start then start = true end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 150 then 
		medal = 'Bronze'
		nextMedal = 'Silver(170)'
	elseif score >= 150 and score < 170 then 
		medal = 'Silver'
		nextMedal = 'Gold(190)'
	elseif score >= 190 and score < 210 then 
		medal = 'Gold'
		nextMedal = 'Platinum(210)'
	elseif score >= 210 and score < 250 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(250)'
	elseif score >= 250 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 4, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = 60-scenarioTime
	scoreFinal = math.floor(scoreFinal+(60-scenarioTime))
	success(scoreFinal, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and data.triggerName ~= 'finish' then
		local targetPts = tonumber(string.match(data.triggerName, '%d+'))
		targetTime = 0.25
		targetScore = targetScore+targetPts
		-- musicTime = scenarioTime
		
		-- if targetScore == 5 then      TorqueScript.eval('targetLow.play();')
		-- elseif targetScore == 10 then TorqueScript.eval('targetMed.play();')
		-- elseif targetScore == 25 then TorqueScript.eval('targetHigh.play();')
		-- end
		
		scoreFinal = scoreFinal+targetPts
	elseif data.triggerName == 'finish' then finish()
	end
end

local function onRaceTick(raceTickTime) 
	scenarioTime = scenarioTime+raceTickTime 
	-- if scenarioTime-musicTime == 1 then 
		-- TorqueScript.eval('targetLow.stop();')
		-- TorqueScript.eval('targetMed.stop();')
		-- TorqueScript.eval('targetHigh.stop();')
	-- end
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M