--Best = 1563

local M = {}

local scoreLand = 0
local distance = 0
local nitro = 0
local active = false
local reset = true
local lightning = {-970, -1035, -1100, -1170, -1235, -1270}
local helper = require('scenario/scenariohelper')
local file = require('scenario/fileHandler')

local function success(score)
	local medal, nextMedal
	if score < 500 then 
		medal = 'None'
		nextMedal = 'Bronze(500)'
	elseif score >= 500 and score < 600 then 
		medal = 'Bronze'
		nextMedal = 'Silver(600)'
	elseif score >= 600 and score < 750 then 
		medal = 'Silver'
		nextMedal = 'Gold(750)'
	elseif score >= 750 and score < 1100 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1100)'
	elseif score >= 1100 and score < 1350 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1350)'
	elseif score >= 1350 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 10, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, "t_nitro") then
		--Adds one second of nitro (runs twice per powerup grabbed)
		nitro = nitro+0.5
		local number = string.match(data.triggerName, "%d+")
		TorqueScript.eval('nitro'..number..'.position = "10000 0 0";')
		ui_message('Nitro: '..nitro..'', 2, 'A')
	elseif data.triggerName == 'ramp' then active = true end
end

local function onPreRender()
	if reset then
		TorqueScript.eval([[
			nitro1.position = "-573.105408 -2034.47937 713.286438";
			nitro2.position = "-558.197021 -1911.03137 659.336609";
			nitro3.position = "-552.875122 -1718.62671 574.602173";
			nitro4.position = "-561.642334 -1535.99841 494.319366";
			nitro5.position = "-546.655151 -1382.66235 427.283112";
			nitro6.position = "-575.258606 -1159.19031 329.171875";
			nitro7.position = "-556.120422 -983.007935 252.071808";
		]])
		reset = false
	end
	
	for i = 1, 6 do
		if lightning[i] >= 1330 then lightning[i] = lightning[i]-2300 end
		lightning[i] = lightning[i]+5
	end
	
	TorqueScript.eval([[
		lightning1.position = "-879.981934 ]]..lightning[1]..[[ 127.704391";
		lightning2.position = "-1183.55066 ]]..lightning[2]..[[ 125.017517";
		lightning3.position = "-1497.91138 ]]..lightning[3]..[[ 125.940094";
		lightning4.position = "-192.466354 ]]..lightning[4]..[[ 125.940094";
		lightning5.position = " 425.463196 ]]..lightning[5]..[[ 127.704391";
		lightning6.position = " 121.894455 ]]..lightning[6]..[[ 125.017517";
	]])
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+561.78, 2) + math.pow(playerObject:getPosition().y+863.361, 2), math.pow(playerObject:getPosition().z+0, 2)))
	if playerObject:getPosition().y < -863.361 then distance = -distance 
	else distance = math.abs(distance)
	end
	
	if active and nitro > 0 then 
		playerObject:queueLuaCommand('obj:setWind(0, 300, 0)')
		nitro = nitro-raceTickTime
		ui_message('Nitro: '..math.floor(nitro)..'s', 1, 'A')
	elseif nitro <= 0 then playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
	end
	
	if playerObject:getPosition().z <= 5 then 
		success(distance) 
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M