--Best = 83486

local M = {}

local helper = require('scenario/scenariohelper')
local scenarioTimeOut = 0
local timeOutLimit = 5
local multiplier = 1
local coil = {1, 11, 22, 33, 44}
local startTimer = false
local reset = true
local powers = {false, false, false, false}
local file = require('scenario/fileHandler')

local function success(score, achieved, team, opponent, multi)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 800 then 
		medal = 'Bronze'
		nextMedal = 'Silver(800)'
	elseif score >= 800 and score < 7000 then 
		medal = 'Silver'
		nextMedal = 'Gold(7000)'
	elseif score >= 7000 and score < 34000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(34000)'
	elseif score >= 34000 and score < 81000 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(81000)'
	elseif score >= 81000 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	local extra = ''
	if not achieved then 
		extra = 'Trophy Unlocked!' 
		file.updateFile(file.getMedalAsNumber(medal), 7, 16, 1)
	else file.updateFile(file.getMedalAsNumber(medal), 7, nil, nil)
	end
	
    local result = {msg = 'Well Done! Your Score: (('..team..'- '..opponent..')*'..multi..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' and (data.subjectName == 'player' or data.subjectName == 'truck') then
		helper.queueLuaCommandByName('player', 'bullettime.set(4)')
		if data.subjectName == 'player' then startTimer = true
		elseif powers[4] then
			local truck = scenetree.findObject('truck')
			truck:queueLuaCommand('obj:setWind(0, 0, 0)')
		end
	end
end

local function checkPowerups(vehicleObject)
	local powerupHelper = require('scenario/powerup')
	
	if not powers[1] and powerupHelper.checkDistance(vehicleObject, 555.1, 739.9, 0.01, 3) then 
		powerupHelper.triggerMultiplier('x2', 0)
		powers[1] = true
		multiplier = multiplier*2
	end
	if not powers[2] and powerupHelper.checkDistance(vehicleObject, 577.7, 732.7, 0.01, 3) then
		powerupHelper.triggerMultiplier('x4', 0)
		powers[2] = true
		multiplier = multiplier*4
	end
	if not powers[3] and powerupHelper.checkDistance(vehicleObject, 582.5, 693.9, 0.01, 3) then
		powerupHelper.triggerMultiplier('x8', 0)
		powers[3] = true
		multiplier = multiplier*8
	end
	
	if not powers[4] and powerupHelper.checkDistance(vehicleObject, 572.8, 720.2, 0.01, 3) then
		powerupHelper.triggerMultiplier('juggernaut', 0)
		powers[4] = true
		--Find truck
		local truck = scenetree.findObject('truck')
		--Apply acceleration to it
		truck:queueLuaCommand('obj:setWind(0, 300, 0)')
	end
end


local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			x2_board.position = "-555.149841 -739.863281 1.85171342";
			x4_board.position = "-577.706238 -732.667053 2.03013372";
			x8_board.position = "-582.549255 -693.898682 1.81479144";
			juggernaut_board.position = "-572.779785 -720.188293 1.900208";
		]])
		reset = false
	end

	for i = 1, 5 do
		if coil[i] == 48 then coil[i] = 0
		else coil[i] = coil[i]+0.5
		end
	end
	
	TorqueScript.eval([[
		coil1.position = "-613.846252 -750.069824 ]]..coil[1]..[[";
		coil2.position = "-518.114380 -749.942627 ]]..coil[2]..[[";
		coil3.position = "-487.102020 -667.635132 ]]..coil[3]..[[";
		coil4.position = "-646.504456 -667.710571 ]]..coil[4]..[[";
		coil5.position = "-562.451538 -603.846252 ]]..coil[5]..[[";
	]])
	
	checkPowerups(scenetree.findObject('player'))
	checkPowerups(scenetree.findObject('player1'))
	checkPowerups(scenetree.findObject('opponent1'))
	checkPowerups(scenetree.findObject('opponent2'))
	checkPowerups(scenetree.findObject('truck'))
end

local function finish()
	local playerObject = scenetree.findObject('player')
	local teamObject = scenetree.findObject('player1')
    local carOpponentObject = scenetree.findObject('opponent1')	
	local carOpponentObject2 = scenetree.findObject('opponent2')	
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
	local distanceTeam = math.floor(math.sqrt(math.pow(teamObject:getPosition().x+563.3, 2) + math.pow(teamObject:getPosition().y+733.6, 2), math.pow(teamObject:getPosition().z+0.01, 2)))
	local distanceOpponent1 = math.floor(math.sqrt(math.pow(carOpponentObject:getPosition().x+563.3, 2) + math.pow(carOpponentObject:getPosition().y+733.6, 2), math.pow(carOpponentObject:getPosition().z+0.01, 2)))
	local distanceOpponent2 = math.floor(math.sqrt(math.pow(carOpponentObject2:getPosition().x+563.3, 2) + math.pow(carOpponentObject2:getPosition().y+733.6, 2), math.pow(carOpponentObject2:getPosition().z+0.01, 2)))

	local scorePlayer = 100-distance
	local scoreTeam = 100-distanceTeam
	local scoreOpponent1 = 100-distanceOpponent1
	local scoreOpponent2 = 100-distanceOpponent2
	
	local trophyUnlocked = false --Check for whether trophy requirement is satisfied
	if scoreTeam >= 95 then trophyUnlocked = true end

	local scoreFinal = (scorePlayer+scoreTeam-scoreOpponent1-scoreOpponent2)*multiplier
	success(scoreFinal, trophyUnlocked, scorePlayer+scoreTeam, scoreOpponent1+scoreOpponent2, multiplier)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	if startTimer then
		scenarioTimeOut = scenarioTimeOut+raceTickTime
		playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
	else 
		playerObject:queueLuaCommand('obj:setWind(0, 200, 0)')
	end

	if scenarioTimeOut >= timeOutLimit then 
		if timeOutLimit == 5 then
			timeOutLimit = 10
			helper.queueLuaCommandByName('player', 'bullettime.set(1)')
			if not powers[4] then finish()
			else scenarioTimeOut = 0
			end
		else
			finish()
		end
	end
end

M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M