--Best = 1376

local M = {}

local scoreLand = 0
local scoreFinal = 0
local scoreRest = 0
local scenarioTime = 0
local distance = 0
local multiplier = 1
local powers = {false, false, false}
local reset = true
local scenarioTimeOut = 0
local file = require('scenario/fileHandler')

local function onRaceStart()
	if not start then start = true end
end

local function success(score)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 200 then 
		medal = 'Bronze'
		nextMedal = 'Silver(200)'
	elseif score >= 200 and score < 350 then 
		medal = 'Silver'
		nextMedal = 'Gold(350)'
	elseif score >= 350 and score < 800 then 
		medal = 'Gold'
		nextMedal = 'Platinum(800)'
	elseif score >= 800 and score < 1375 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1100)'
	elseif score >= 1100 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 6, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'x2_1' and not powers[1] then
		ui_message('X2 got!', 3, 'A')
		multiplier = multiplier*2
		TorqueScript.eval([[
			x2_1_board.position = "10000 0 0";
		]])
		powers[1] = true
	elseif data.triggerName == 'x2_2' and not powers[2] then
		ui_message('X2 got!', 3, 'A')
		multiplier = multiplier*2
		TorqueScript.eval([[
			x2_2_board.position = "10000 0 0";
		]])
		powers[2] = true
	elseif data.triggerName == 'x4' and not powers[3] then
		ui_message('X4 got!', 3, 'A')
		multiplier = multiplier*4
		TorqueScript.eval([[
			x4_board.position = "10000 0 0";
		]])
		powers[3] = true
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			x2_1_board.position = "-565.360962 -816.901672 174.649948";
			x2_2_board.position = "-565.509033 -816.797974 205.014297";
			x4_board.position = "-542.705994 -731.764465 78.4587708";
		]])
		reset = false
	end
end

local function finish()
	if scoreLand == 0 then
		local playerObject = scenetree.findObject('player')
		distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+683.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
		scoreLand = 100-distance 
	end
	
	scoreRest = 100-distance
	scoreFinal = (scoreLand+scoreRest)*multiplier
	success(scoreFinal)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	scenarioTimeOut = scenarioTimeOut+raceTickTime
	
	if scenarioTimeOut >= 35 then finish() end
	
	if scoreLand == 0 then
		if playerObject:getPosition().z <= 5 then
			scoreLand = 100-distance 
		end
	else
		local playerData = map.objects[map.objectNames['player']]
		scenarioTime = scenarioTime+raceTickTime
		if scenarioTime >= 8 or playerData.vel:length() <= 0.025 then
			finish()
		else
			distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+683.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
		end
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M