--Best = 427

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local targetScore = -1
local targetTime = 0
local file = require('scenario/fileHandler')
local helper = require('scenario/scenariohelper')

local function onRaceStart()
	if not start then start = true end
end

local function success(score, trophy, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 200 then 
		medal = 'None'
		nextMedal = 'Bronze(200)'
	elseif score >= 200 and score < 300 then 
		medal = 'Bronze'
		nextMedal = 'Silver(300)'
	elseif score >= 300 and score < 400 then 
		medal = 'Silver'
		nextMedal = 'Gold(400)'
	elseif score >= 400 and score < 410 then 
		medal = 'Gold'
		nextMedal = 'Platinum(410)'
	elseif score >= 410 and score < 420 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(420)'
	elseif score >= 420 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	local extra = ''
	if trophy then 
		extra = 'Trophy Unlocked!' 
		file.updateFile(file.getMedalAsNumber(medal), 9, 18, 1)
	else file.updateFile(file.getMedalAsNumber(medal), 9, nil, nil)
	end
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = 60-scenarioTime
	local trophyAchieved = false
	scoreFinal = math.floor(scoreFinal+(60-scenarioTime))
	if scoreFinal == 0 then trophyAchieved = true end
	success(scoreFinal, trophyAchieved, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and data.triggerName ~= 'finish' then
		local targetPts = tonumber(string.match(data.triggerName, '%d+'))
		targetTime = 0.25
		targetScore = targetScore+targetPts
		scoreFinal = scoreFinal+targetPts
	elseif data.triggerName == 'finish' then finish()
	end
end

local function onRaceTick(raceTickTime)
	scenarioTime = scenarioTime+raceTickTime 
	
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M