--Best = 10708

local M = {}

local scoreLand = 0
local distance = 0
local nitro = 0
local satellitePos = 0
local active = false
local reset = true
local start = false
local blackhole = false
local bScale = true
local teleported = false
local distTracker = {["asteroid"] = 0, ["satellite"] = 0, ["star"] = 0}
local scale = {50, 50, 1}
local rotation = {0, 0, 0, 0, 0}
local asteroids = {true, true, true, true, true}
local planets = {true, true, false, 0, 0}
local neutron = {["left"] = false, ["right"] = false, ["up"] = false}
local trophy = false
local file = require('scenario/fileHandler')

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		local playerObject = scenetree.findObject('player')
		playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
	end
end

local function onRaceStart()
	if not reset then reset = true end
end

local function success(score)
	local medal, nextMedal
	if score < 3500 then 
		medal = 'None'
		nextMedal = 'Bronze(3500)'
	elseif score >= 3500 and score < 5000 then 
		medal = 'Bronze'
		nextMedal = 'Silver(5000)'
	elseif score >= 5000 and score < 6500 then 
		medal = 'Silver'
		nextMedal = 'Gold(6500)'
	elseif score >= 6500 and score < 9000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(9000)'
	elseif score >= 9000 and score < 9000 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(9500)'
	elseif score >= 9500 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	elseif score >= 10000 then
		medal = 'Singularity'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	local extra = ''
	trophy = true
	if trophy then 
		extra = 'Trophy unlocked for speed!' 
		file.updateFile(file.getMedalAsNumber(medal), 15, 19, 1)
	else file.updateFile(file.getMedalAsNumber(medal), 15, nil, nil)
	end
	
	local result
	if medal == 'Singularity' then result = {msg = 'Well Done! You somehow managed to reach 10KM and went into the blackhole. I suppose the only reward we can give you is the blackhole crystallised...so...enjoy it while you can! Your Score: '..score..' | You Achieved: '..medal..' '..extra..' '}
    else result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..' '..extra..' '}
	end
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, "t_nitro") then
		nitro = nitro+0.5
		local number = string.match(data.triggerName, "%d+")
		TorqueScript.eval('nitro'..number..'.position = "10000 0 0";')
		ui_message('Nitro: '..nitro..'', 2, 'A')
	elseif string.find(data.triggerName, "neutron") then
		local playerObject = scenetree.findObject('player')
		if data.triggerName == 'neutron_left' then 
			if not neutron["left"] then 
				playerObject:queueLuaCommand('obj:setWind(-300, 0, 0)')
				neutron["left"] = true
			elseif neutron["left"] then 
				playerObject:queueLuaCommand('obj:setWind(0, 0, 0)') 
				neutron["left"] = false
			end
		elseif data.triggerName == 'neutron_right' then 
			if not neutron["right"] then 
				playerObject:queueLuaCommand('obj:setWind(300, 0, 0)')
				neutron["right"] = true
			elseif neutron["right"] then 
				playerObject:queueLuaCommand('obj:setWind(0, 0, 0)') 
				neutron["right"] = false
			end
		else 
			if not neutron["up"] then 
				playerObject:queueLuaCommand('obj:setWind(0, 0, 135)')
				neutron["up"] = true
			elseif neutron["up"] then 
				playerObject:queueLuaCommand('obj:setWind(0, 0, 0)') 
				neutron["up"] = false
			end 
		end
	elseif data.triggerName == 'supernova' then blackhole = true 
	elseif data.triggerName == 'blackhole' then 
		local playerObject = scenetree.findObject('player')
		playerObject:queueLuaCommand('obj:setWind(0, 155, 0)')
	elseif data.triggerName == 'nitro' then active = true 
	elseif data.triggerName == 'portalEntry' then 
		teleported = true 
		TorqueScript.eval([[
			player.position = "-562.856 -3518.07 4786.36";
			grid.position = "-10576.5146 -223.188004 2000";
		]])
	end
end

local function onPreRender(dt)
	local scenarioTime = dt*60
	if reset then
		TorqueScript.eval([[
			comet1.position = "-405.826935 -2940.05908 1119.08582";
			comet2.position = "-851.518433 -2856.51025 1087.06958";
			comet3.position = "-271.265259 -2695.08203 1018.81836";
			asteroid1.position = "-573.458252 -2560.68628 946.783447";
			asteroid2.position = "-558.940063 -2481.86572 912.536255";
			asteroid3.position = "-570.916992 -2395.38892 874.797974";
			asteroid4.position = "-561.690857 -2324.34448 843.142700";
			asteroid5.position = "-571.708740 -2292.50366 829.185791";
			crater1.position = "10000 0 0";
			crater2.position = "10000 0 0";
			crater3.position = "10000 0 0";
			crater4.position = "10000 0 0";
			crater5.position = "10000 0 0";
			portal1.position = "-2036.5741 -1516.38806 792.553345";
			satelliteHalf1.position = "-2125.9624 -1528.96204 789.931396";
			satelliteHalf2.position = "-1915.32996 -1514.93005 789.93103";
			satelliteHalf1.rotation = "0 0 0 1";
			satelliteHalf2.rotation = "0 0 0 1";
			starOuter.scale = "2750 2750 2750";
			starInner.scale = "50 50 50";
			accretionDisc.scale = "0 0 0";
			turbine1.rotation = "0 -1 0 0";
			turbine2.rotation = "0 -1 0 0";
			turbine3.rotation = "0 -1 0 0";
			turbine4.rotation = "0 -1 0 0";
			turbine5.rotation = "0 -1 0 0";
			turbine6.rotation = "0 -1 0 0";
			turbine7.rotation = "0 -1 0 0";
			nitro1.position = "-573.105408 -2034.47937 713.286438";
			nitro2.position = "-582.646973 -2913.84326 1098.96887";
			nitro3.position = "-570.816589 -3190.14917 4644.50244";
			nitro4.position = "-552.564514 -2752.23315 4451.53223";
			nitro5.position = "-557.574463 -2306.74243 4256.14746";
			nitro6.position = "-556.565735 -1698.71362 3989.76563";
			nitro7.position = "-573.052368 -1122.34949 3736.87695";
			nitro8.position = "-572.622681 -869.788696 3626.05811";
			nitro9.position = "-548.304199 -2450.87012 896.212708";
			nitro10.position = "-558.15979 -2149.40503 4187.50391";
			grid.position = "-100000 -223.188004 3000";
			explosion1.scale = "0 0 0";
		]])
		be:reloadStaticCollision();
		TorqueScript.eval([[
			asteroid1.position = "-573.458252 -2560.68628 1500";
			asteroid2.position = "-558.940063 -2481.86572 1550";
			asteroid3.position = "-570.916992 -2395.38892 1600";
			asteroid4.position = "-561.690857 -2324.34448 1650";
			asteroid5.position = "-571.708740 -2292.50366 1700";
		]])
		reset = false
	end
	
	if start then
		rotation[4] = rotation[4]+0.125
		planets[4] = planets[4]+scenarioTime*2
		if not planets[3] then
			TorqueScript.eval([[
				satelliteHalf1.position = "]]..(-2125.96240+planets[4])..[[ -1514.93127 789.931396";
				satelliteHalf2.position = "]]..(-1915.33276+planets[4])..[[ -1528.96204 789.931396";
				portal1.position        = "]]..(-2036.57410+planets[4])..[[ -1516.38806 792.553345";
			]])
			satellitePos = -2125.96240+planets[4]
		end
	
		distTracker["asteroid"] = distTracker["asteroid"]+scenarioTime
		TorqueScript.eval([[
			comet1.position  = "]]..(-405.826935-distTracker["asteroid"])..[[ -2940.05908 1119.08582";
			comet2.position  = "]]..(-851.518433+distTracker["asteroid"])..[[ -2856.51025 1087.06958";
			comet3.position  = "]]..(-271.265259-distTracker["asteroid"])..[[ -2695.08203 1018.81836";
			comet4.position  = "]]..(-920.000671+distTracker["asteroid"])..[[ -2781.50269 1064.15076";
			comet5.position  = "]]..(-193.641663-distTracker["asteroid"])..[[ -2715.80273 956.892395";
			comet6.position  = "]]..(-1019.10236+distTracker["asteroid"])..[[ -2666.71973 1035.51392";
		]])
		
		if asteroids[1] then TorqueScript.eval('asteroid1.position = "-573.458252 -2560.68628 '..(1500-distTracker["asteroid"])..'";') end
		if asteroids[2] then TorqueScript.eval('asteroid2.position = "-558.940063 -2481.86572 '..(1550-distTracker["asteroid"])..'";') end
		if asteroids[3] then TorqueScript.eval('asteroid3.position = "-570.916992 -2395.38892 '..(1600-distTracker["asteroid"])..'";') end
		if asteroids[4] then TorqueScript.eval('asteroid4.position = "-561.690857 -2324.34448 '..(1650-distTracker["asteroid"])..'";') end
		if asteroids[5] then TorqueScript.eval('asteroid5.position = "-571.708740 -2292.50366 '..(1700-distTracker["asteroid"])..'";') end

		if planets[3] then
			planets[5] = planets[5]+scenarioTime
			if planets[5]*planets[5] < 1000 then TorqueScript.eval('explosion1.scale = "'..(planets[5]*planets[5])..' ' ..(planets[5]*planets[5])..' '..(planets[5]*planets[5])..'";')
			else TorqueScript.eval('explosion1.scale = "0 0 0";') end
			TorqueScript.eval([[
				
				satelliteHalf2.position = "]]..(-1915.33276+planets[4])..[[ -1514.93127 789.931396";
				satelliteHalf2.rotation = "]]..rotation[3]..[[ ]]..rotation[3]..[[ ]]..rotation[3]..[[ ]]..rotation[3]..[[";
			]])
			if 789.931396-planets[5] > 475 then 
				TorqueScript.eval([[
					satelliteHalf1.position = "]]..satellitePos..[[ -1514.93127 ]]..(789.931396-planets[5])..[[";
					portal1.position = "-595 -1480 ]]..(770-planets[5])..[[";
					portalEntry.position = "-565.399048 -1471.07666 ]]..(800-planets[5])..[[";
					satelliteHalf1.rotation = "0 0 -1 ]]..rotation[4]..[[";
				]])
			end
		end
		
		if 1500-distTracker["asteroid"] <= 946.783447 and asteroids[1] then 
			asteroids[1] = false
			TorqueScript.eval('crater1.position = "-572.849915 -2562.41211 942.973853";')
			--be:reloadStaticCollision();
		end
		if 1550-distTracker["asteroid"] <= 912.536255 and asteroids[2] then
			asteroids[2] = false
			TorqueScript.eval('crater2.position = "-558.331726 -2483.59131 908.32666";')
			--be:reloadStaticCollision();
		end
		if 1600-distTracker["asteroid"] <= 874.797974 and asteroids[3] then
			asteroids[3] = false
			TorqueScript.eval('crater3.position = "-570.308655 -2397.1145 870.788379";')
			--be:reloadStaticCollision();
		end
		if 1650-distTracker["asteroid"] <= 843.1427 and asteroids[4] then
			asteroids[4] = false
			planets[3] = true
			TorqueScript.eval('crater4.position = "-561.08252 -2326.07007 839.333105";')
			--be:reloadStaticCollision();
		end
		if 1700-distTracker["asteroid"] <= 829.185791 and asteroids[5] then
			asteroids[5] = false
			TorqueScript.eval('crater5.position = "-571.100403 -2294.22925 825.276196";')
			--be:reloadStaticCollision();
		end
	end
	
	rotation[1] = rotation[1]+1
	rotation[2] = rotation[2]+3
	rotation[5] = rotation[5]+4
	
	TorqueScript.eval([[
		neutron1.rotation =        "0 0 1 ]]..rotation[2]..[[";
		neutron2.rotation =        "0 0 1 ]]..rotation[2]..[[";
		neutron3.rotation =        "0 0 1 ]]..rotation[2]..[[";
		neutron4.rotation =        "0 0 1 ]]..rotation[2]..[[";
		neutron5.rotation =        "0 0 1 ]]..rotation[2]..[[";
		turbine1.rotation =        "0 1 0 ]]..rotation[5]..[[";
		turbine2.rotation =        "0 1 0 ]]..rotation[5]..[[";
		turbine3.rotation =        "0 1 0 ]]..rotation[5]..[[";
		turbine4.rotation =        "0 1 0 ]]..rotation[5]..[[";
		turbine5.rotation =        "0 1 0 ]]..rotation[5]..[[";
		turbine6.rotation =        "0 1 0 ]]..rotation[5]..[[";
		turbine7.rotation =        "0 1 0 ]]..rotation[5]..[[";
	]])
	
	if teleported then 
		if blackhole then
			distTracker["star"] = distTracker["star"]+(scenarioTime*55)
			
			if distTracker["star"] >= 100 then
				if distTracker["star"] > 101 then
					if scale[1] > 45 then scale[1] = scale[1]-(scenarioTime/1)
					elseif scale[1] > 0 then scale[1] = scale[1]-(scenarioTime/3)
					elseif scale[1] == 0 then 
						if scale[3] < 700 then scale[3] = scale[3]+scenarioTime end
					elseif scale[1] < 0 then scale[1] = 0 
					end
					
					if scale[2] < 10000 and bScale then 
						local multi = scenarioTime
						if multi < 1.01 then multi = 1.01 end
						scale[2] = scale[2]*multi
					else 
						scale[2] = 0
						bScale = false
					end
					
					TorqueScript.eval([[
						starInner.scale     = "]]..scale[1]..[[ ]]..scale[1]..[[ ]]..scale[1]..[[";
						starOuter.scale     = "]]..scale[2]..[[ ]]..scale[2]..[[ ]]..scale[2]..[[";
						accretionDisc.scale = "]]..scale[3]..[[ ]]..scale[3]..[[ ]]..scale[3]..[[";
						accretionDisc.rotation = "0 1 0 ]]..(rotation[2]*2)..[[";
					]])
				end
			end
		end
	end
	
end

local function onRaceTick(raceTickTime)
	if not start then start = true end

	local playerObject = scenetree.findObject('player')
	distance = math.floor(playerObject:getPosition().y)
	if active and nitro > 0 then 
		playerObject:queueLuaCommand('obj:setWind(0, 855, 0)')
		nitro = nitro-raceTickTime
		ui_message('Nitro: '..math.floor(nitro)..'s', 1, 'A')
	elseif nitro <= 0 and active then playerObject:queueLuaCommand('obj:setWind(0, 155, 0)')
	end
	
	if playerObject:getPosition().z <= 2005 and blackhole then success(distance) end
	
	if not active then
		local playerData = map.objects[map.objectNames['player']]
		if playerData.vel:length() >= 153.335 then trophy = true end
	end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
M.onScenarioChange = onScenarioChange
return M