--Best = 2368

local M = {}

local helper = require('scenario/scenariohelper')
local powerupHelper = require('scenario/powerup')
local scenarioTimeOut = 0
local timeOutLimit = 5
local multiplier = 1
local startTimer = false
local reset = true
local rotation = 0
local powers = {false, false, false}
local file = require('scenario/fileHandler')

local function success(score, team, opponent, multi)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 300 then 
		medal = 'Bronze'
		nextMedal = 'Silver(300)'
	elseif score >= 300 and score < 750 then 
		medal = 'Silver'
		nextMedal = 'Gold(750)'
	elseif score >= 750 and score < 1000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1000)'
	elseif score >= 1000 and score < 2000 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(2000)'
	elseif score >= 2000 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 12, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: (('..team..'- '..opponent..')*'..multi..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' and (data.subjectName == 'player' or data.subjectName == 'truck') then
		helper.queueLuaCommandByName('player', 'bullettime.set(4)')
		if data.subjectName == 'player' then startTimer = true
		elseif powers[4] then
			local truck = scenetree.findObject('truck')
			truck:queueLuaCommand('obj:setWind(0, 0, 0)')
		end
	end
end

local function checkPowerups(vehicleObject)	
	if not powers[1] and powerupHelper.checkDistance(vehicleObject, 556.687866, 737.830566, 0.01, 3) then 
		powerupHelper.triggerMultiplier('x2', 0)
		powers[1] = true
		multiplier = multiplier*2
	end
	if not powers[2] and powerupHelper.checkDistance(vehicleObject, 571.421021, 726.786255, 0.01, 3) then
		powerupHelper.triggerMultiplier('x4', 0)
		powers[2] = true
		multiplier = multiplier*4
	end
	
	if not powers[3] and powerupHelper.checkDistance(vehicleObject, 564.162292, 760.322327, 0.01, 3) then
		powerupHelper.triggerMultiplier('juggernaut', 0)
		powers[3] = true
		--Find truck
		local truck = scenetree.findObject('truck')
		--Apply acceleration to it
		truck:queueLuaCommand('obj:setWind(0, 300, 0)')
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			x2_board.position = "-556.687866 -737.830566 1.85171342";
			x4_board.position = "-571.421021 -726.786255 2.03013372";
			juggernaut_board.position = "-564.162292 -760.322327 1.90509307";
		]])
		reset = false
	end
	
	rotation = rotation+0.5
	TorqueScript.eval('moon.rotation = "0 0 1 '..rotation..'";')
	
	checkPowerups(scenetree.findObject('player'))
	checkPowerups(scenetree.findObject('player1'))
	checkPowerups(scenetree.findObject('opponent1'))
	checkPowerups(scenetree.findObject('opponent2'))
	checkPowerups(scenetree.findObject('opponent3'))
	checkPowerups(scenetree.findObject('truck'))
end

local function finish()
	local playerObject = scenetree.findObject('player')
	local teamObject = scenetree.findObject('player1')
    local carOpponentObject = scenetree.findObject('opponent1')	
	local carOpponentObject2 = scenetree.findObject('opponent2')	
	local carOpponentObject3 = scenetree.findObject('opponent3')	
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
	local distanceTeam = math.floor(math.sqrt(math.pow(teamObject:getPosition().x+563.3, 2) + math.pow(teamObject:getPosition().y+733.6, 2), math.pow(teamObject:getPosition().z+0.01, 2)))
	local distanceOpponent1 = math.floor(math.sqrt(math.pow(carOpponentObject:getPosition().x+563.3, 2) + math.pow(carOpponentObject:getPosition().y+733.6, 2), math.pow(carOpponentObject:getPosition().z+0.01, 2)))
	local distanceOpponent2 = math.floor(math.sqrt(math.pow(carOpponentObject2:getPosition().x+563.3, 2) + math.pow(carOpponentObject2:getPosition().y+733.6, 2), math.pow(carOpponentObject2:getPosition().z+0.01, 2)))
	local distanceOpponent3 = math.floor(math.sqrt(math.pow(carOpponentObject3:getPosition().x+563.3, 2) + math.pow(carOpponentObject3:getPosition().y+733.6, 2), math.pow(carOpponentObject3:getPosition().z+0.01, 2)))

	local scorePlayer = 100-distance
	local scoreTeam = 100-distanceTeam
	local scoreOpponent1 = 100-distanceOpponent1
	local scoreOpponent2 = 100-distanceOpponent2
	local scoreOpponent3 = 100-distanceOpponent3

	local scoreFinal = (scorePlayer+scoreTeam-scoreOpponent1-scoreOpponent2-scoreOpponent3)*multiplier
	success(scoreFinal, scorePlayer+scoreTeam, scoreOpponent1+scoreOpponent2+scoreOpponent3, multiplier)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	if startTimer then
		scenarioTimeOut = scenarioTimeOut+raceTickTime
		playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
	else 
		playerObject:queueLuaCommand('obj:setWind(0, 200, 0)')
	end

	if scenarioTimeOut >= timeOutLimit then 
		if timeOutLimit == 5 then
			timeOutLimit = 10
			helper.queueLuaCommandByName('player', 'bullettime.set(1)')
			if not powers[3] then finish()
			else scenarioTimeOut = 0
			end
		else
			finish()
		end
	end
end

M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M