--Best = 5344

local M = {}

local scoreLand = 0
local scoreFinal = 0
local scoreRest = 0
local scenarioTime = 0
local distance = 0
local multiplier = 1
local rotation = 0
local powers = {false, false, false}
local reset = true
local scenarioTimeOut = 0
local file = require('scenario/fileHandler')

local function success(score)
	local medal, nextMedal
	if score < 200 then 
		medal = 'None'
		nextMedal = 'Bronze(200)'
	elseif score >= 200 and score < 500 then 
		medal = 'Bronze'
		nextMedal = 'Silver(500)'
	elseif score >= 500 and score < 1000 then 
		medal = 'Silver'
		nextMedal = 'Gold(1000)'
	elseif score >= 1000 and score < 1500 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1500)'
	elseif score >= 1500 and score < 5000 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(5000)'
	elseif score >= 5000 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 11, nil, nil)

    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'x2' and not powers[1] then
		ui_message('X2 got!', 3, 'A')
		multiplier = multiplier*2
		TorqueScript.eval([[
			x2_board.position = "10000 0 0";
		]])
		powers[1] = true
	elseif data.triggerName == 'x4' and not powers[2] then
		ui_message('X4 got!', 3, 'A')
		multiplier = multiplier*4
		TorqueScript.eval([[
			x4_board.position = "10000 0 0";
		]])
		powers[2] = true
	elseif data.triggerName == 'x8' and not powers[3] then
		ui_message('X8 got!', 3, 'A')
		multiplier = multiplier*8
		TorqueScript.eval([[
			x8_board.position = "10000 0 0";
		]])
		powers[3] = true
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			x2_board.position = "-564.569092 -855.197632 461.285461";
			x4_board.position = "-564.336304 -813.261292 193.390961";
			x8_board.position = "-569.092468 -856.675842 432.230072";
		]])
		reset = false
	end
	
	rotation = rotation+0.125
	TorqueScript.eval('satellite1.rotation = "1 0 0 '..rotation..'";')
end

local function finish()
	if scoreLand == 0 then
		local playerObject = scenetree.findObject('player')
		distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+798, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
		scoreLand = 100-distance 
	end
	
	scoreRest = 100-distance
	scoreFinal = (scoreLand+scoreRest)*multiplier
	success(scoreFinal)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	scenarioTimeOut = scenarioTimeOut+raceTickTime
	
	if scenarioTimeOut >= 35 then finish() end
	
	if scoreLand == 0 then
		local playerObject = scenetree.findObject('player')
		if playerObject:getPosition().z <= 195 then 
			distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+798, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
			scoreLand = 100-distance
		end
	else
		local playerData = map.objects[map.objectNames['player']]
		scenarioTime = scenarioTime+raceTickTime
		if scenarioTime >= 8 or playerData.vel:length() <= 0.025 then finish()
		else distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+564, 2) + math.pow(playerObject:getPosition().y+798, 2), math.pow(playerObject:getPosition().z+0.01, 2))) end
	end
end


M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
return M