--Best = 1090

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local targetScore = -1
local targetTime = 0
local file = require('scenario/fileHandler')
local helper = require('scenario/scenariohelper')

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		local playerObject = scenetree.findObject('player')
		playerObject:queueLuaCommand('obj:setGravity(-9.81)')
	end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 950 then 
		medal = 'None'
		nextMedal = 'Bronze(950)'
	elseif score >= 950 and score < 1000 then 
		medal = 'Bronze'
		nextMedal = 'Silver(1000)'
	elseif score >= 1000 and score < 1020 then 
		medal = 'Silver'
		nextMedal = 'Gold(1020)'
	elseif score >= 1020 and score < 1040 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1040)'
	elseif score >= 1040 and score < 1060 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1060)'
	elseif score >= 1060 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 14, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = (150-scenarioTime)*10
	local playerObject = scenetree.findObject('player')
	playerObject:queueLuaCommand('obj:setGravity(-9.81)')
	scoreFinal = scoreFinal+(150-scenarioTime)*10
	success(scoreFinal, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and data.triggerName ~= 'finish' then
		if data.triggerName == 'reset' then TorqueScript.eval('player.rotation = "0 0 1 90";')
		elseif string.find(data.triggerName, 'zeroGravity') then
			local playerObject = scenetree.findObject('player')
			playerObject:queueLuaCommand('obj:setGravity(0)')
		elseif string.find(data.triggerName, 'earthGravity') then
			local playerObject = scenetree.findObject('player')
			playerObject:queueLuaCommand('obj:setGravity(-9.81)')
		else
			local targetPts = tonumber(string.match(data.triggerName, '%d+'))
			targetTime = 0.25
			targetScore = targetScore+targetPts
			scoreFinal = scoreFinal+targetPts
		end
	elseif data.triggerName == 'finish' then finish()
	end
end

local function onRaceTick(raceTickTime)
	scenarioTime = scenarioTime+raceTickTime 
	
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
end

M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
return M