local M = {}

--Number of medals+trophies that can be won
local currentMedals = 25

--Used to update the savefile
--                  medalAchieved, indexOfScenario, indexOfTrophy, numberOfTrophy
local function updateFile(newMedal, scenarioDigit, trophyDigit, trophy)
	local file = io.open("cargames_save.txt", "r")
	if file == nil then 
		file = io.open("cargames_save.txt", "w")
		file:write('0000000000000000000') --Setup save data
	end
	
	local medals = file:read()
	file:close()
	
	--For updating - adds in required digits to savefile to make save successful
	if #medals < currentMedals then 
		for i = #medals, currentMedals-#medals do file:write(5) end
	end
	
	local medalsTable = {}
	local update, forceUpdate = true
	--loop through save 'number'
	for i = 1, #medals do
		local number = tonumber(medals:sub(i,i))		
		if trophyDigit ~= nil and i == trophyDigit then 
			number = trophy
			forceUpdate = true
		elseif i == scenarioDigit then
			--Update medal if previus medal is less
			if number < newMedal then number = newMedal 
			else update = false
			end
		end
		table.insert(medalsTable, number)
	end
	
	if update or forceUpdate then --Whether a medal needs updating
		local newString = '' --Remake the 'number' as a string
		for key, value in pairs(medalsTable) do --Loops through table of medals
			local subString = value
			newString = newString .. subString --Adds resultant string with next string in table
		end
		
		local file = io.open("cargames_save.txt", "w")
		file:write(newString)
		file:close()
	end
end

local function getMedalAsNumber(medal)
	if     medal == 'None'     then return 0
	elseif medal == 'Bronze'   then return 1
	elseif medal == 'Silver'   then return 2
	elseif medal == 'Gold'     then return 3
	elseif medal == 'Platinum' then return 4
	elseif medal == 'Diamond'  then return 5
	end
end

M.updateFile = updateFile
M.getMedalAsNumber = getMedalAsNumber

return M